"{ Package: 'cvut:stx/goodies/newcompiler' }"

LibraryDefinition subclass:#cvut_stx_goodies_newcompiler
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!cvut_stx_goodies_newcompiler class methodsFor:'description'!

preRequisites
    ^ #(
        #'stx:goodies/refactoryBrowser/parser'    "RBIdentifierToken - referenced by IRDecompiler>>newVar: "
        #'stx:goodies/sunit'    "TestCase - superclass of IRTransformTest "
        #'stx:libbasic'    "Link - superclass of IRLine "
        #'stx:libbasic2'    "OrderedDictionary - referenced by IRBytecodeGenerator>>initialize "
        #'stx:libcomp'    "PrimitiveNode - referenced by IRFunction>>initialize "
        #'stx:libcompat'    "Preferences - referenced by IRDecompiler>>removeClosureCreation: "
        #'stx:libwidg'    "ScrollableView - referenced by IRFunction>>inspector2TabIRCode "
    )

    "Modified: / 17-09-2012 / 09:58:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!cvut_stx_goodies_newcompiler class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        IRBuilder
        IRBuilderTest
        IRBytecodeGenerator
        IRFunction
        IRInstruction
        IRInterpreter
        IRSequence
        IRStackCount
        IRTransformTest
        #'cvut_stx_goodies_newcompiler'
        IRAccess
        IRClosure
        IRConstant
        IRDecompiler
        IRDup
        IRJump
        IRLine
        IRMethod
        IRPop
        IRPrinter
        IRReturn
        IRSend
        IRTranslator
        IRBlockReturnTop
        IRInstVarAccess
        IRJumpIf
        IRJumpOverBlock
        IRLiteralVariableAccess
        IRTempAccess
        IRInstVarRead
        IRInstVarStore
        IRLiteralVariableRead
        IRLiteralVariableStore
        IRTempRead
        IRTempStore
    )
!

extensionMethodNames
    ^ #(
        ByteCodeCompiler literalArray:
        Class binding
        Class bindingOf:
    )
! !

!cvut_stx_goodies_newcompiler class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'CVUT FEI & Mathieu Suen'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Bytecode generation library based on Squeak''s NewCompiler'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Jan Vrany & Mathieu Suen 2008'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'NewCompiler'

    "Created: / 11-06-2008 / 16:50:46 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!cvut_stx_goodies_newcompiler class methodsFor:'description - svn'!

svnRepositoryUrlString
    "Return a SVN repository URL of myself.
     (Generated since 2011-04-08)
     Do not make the string shorter!!!!!! We have to use fixed-length keyword!!!!!!
    "        

    ^ '$URL::                                                                                                                        $'
!

svnRevisionNr
    "Return a SVN revision number of myself.
     This number is updated after a commit"

    ^ "$SVN-Revision:"nil"$"

    "Modified: / 17-09-2012 / 10:02:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!cvut_stx_goodies_newcompiler class methodsFor:'documentation'!

version
    ^ '$Id$'
!

version_CVS
    ^ 'Header: /cvs/stx/cvut/stx/goodies/newcompiler/cvut_stx_goodies_newcompiler.st,v 1.4 2009/10/08 12:00:46 fm Exp '
!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
